
/**
 * Die Testperson wird durch die Maus gesteuert.
 * 
 * @author Klaus Reinold
 * @version 1.0
 */
class Testperson extends Figur
{
    /**
     * Breite des Fensters, in dem sich die Figur bewegt
     */
    int breite;
    /**
     * Höhe des Fensters, in dem sich die Figur bewegt
     */    
    int höhe;

    /**
     * Legt die Testperson an.
     */
    Testperson()
    {
        breite = 800;
        höhe = 600;
        PositionSetzen(30, 30);
        WinkelSetzen(0);
        FigurteilFestlegenEllipse(-20, -20, 40, 40,  "rot");
        FigurteilFestlegenDreieck(-10, -10, +16, 0, -10, +10, "gelb");
    }
    
    /**
     * Bewegt die Figur taktgesteuert im Fenster
     */
    @Override void AktionAusführen()
    {
        int xalt = XPositionGeben();
        int yalt = YPositionGeben();
        Gehen(10);
        if ((XPositionGeben() < 0) && (XPositionGeben() < xalt) || (XPositionGeben() > breite) && (XPositionGeben() > xalt) ||
            (YPositionGeben() < 0) && (YPositionGeben() < yalt) || (YPositionGeben() > höhe) && (YPositionGeben() > yalt) ||
            (Berührt("weiß") || Berührt("blau")))
        {
            PositionSetzen(xalt, yalt);
        }
    }
    
    /**
     * Die eigentliche Aktionsmethode für einen Mausklick, Figur bewegt sich in Richtung Klick
     * @param x x-Position des Mausklicks
     * @param y y-Position des Mausklicks
     * @param anzahl Anzahl der aufeinanderfolgenden Mausklicks
     */
    @Override void MausGeklickt (int x, int y, int anzahl)
    {
        int richtung;
        richtung = RichtungGeben(x, y);
        WinkelSetzen(richtung);
    }
    
    /**
     * Wird bei Mausklick aufgerufen, um die Bewegungsrichtung der Testperson zu ermitteln.
     * @param xMaus x-Koordinate der Maus
     * @param yMaus y-Koordinate der Maus
     * @return Richtungswinkel zum Klickpunkt
     */
    int RichtungGeben (int xMaus, int yMaus)
    {
        double dx = xMaus - XPositionGeben();
        double dy = yMaus - YPositionGeben();
        int richtung = 0;
        if (dx == 0)
        {
            if (dy > 0)
            {
                richtung = 270;
            }
            else if (dy < 0)
            {
                richtung = 90;
            }
        }
        else if (dx > 0)
        {
            richtung = -((int) Math.round(Math.atan(dy / dx) * 180.0 / Math.PI));
        }
        else
        {
            richtung = 180 - ((int) Math.round(Math.atan(dy / dx) * 180.0 / Math.PI));
        }
        return richtung;
    }
}
