/**
 * Das triviale Spiel
 * 
 * @author Klaus Reinold
 * @version 1.0
 */
class Spiel extends Ereignisbehandlung
{
    /** Punktestand des Spiels */
    int punktestand;
    /** Spiel beendet? */
    boolean spielBeendet;
    /** Namenseingabe beendet? */
    boolean namenseingabeBeendet;
    /** Name */
    String name;
    /** Rechteck 1 zur "Spiel"steuerung */
    Rechteck r1;
    /** Rechteck 2 zur "Spiel"steuerung */
    Rechteck r2;
    /** Hinweistext */
    Text hinweis;
    /** Text für Punktestand */
    Text punkteText;

    /**
     * Konstruktor für Objekte der Klasse Spiel
     */
    Spiel()
    {
        super();
    
        punktestand = 0;
        spielBeendet = false;
        namenseingabeBeendet = false;
        name = "";

        r1 = new Rechteck();  
        r1. FarbeSetzen("grün");

        r2 = new Rechteck();
        r2. PositionSetzen(110, 10);
        r2. FarbeSetzen("rot");

        hinweis = new Text();
        hinweis.PositionSetzen(20, 200);
        hinweis.TextSetzen("Klicke auf grün, um Punkte zu sammeln, rot zum Beenden des Spiels.");

        punkteText = new Text();
        punkteText.PositionSetzen(20, 220);
        punkteText.TextSetzen("Punktestand: 0 Punkte");
    }

    /**
     * Routine für Mausereignis (Klick auf Rechtecke)
     * @param x x-Position
     * @param y y-Position
     * @param anzahl Anzahl der Klicks
     */
    @Override void MausGeklickt(int x, int y, int anzahl)
    {
        // wenn "grün" geklickt und das Spiel noch nicht beendet ist...
        if(x > 10 && x < 110 && y > 10 && y < 110 && !spielBeendet)
        {
            punktestand = punktestand + 1;
            punkteText.TextSetzen("Punktestand: " + punktestand + " Punkte");
        }

        // wenn "rot" geklickt, wird das Spiel beendet
        if(x > 110 && x < 210 && y > 10 && y < 110 && !spielBeendet)
        {
            spielBeendet = true;
            hinweis.TextSetzen("Gib nun deinen Namen ein, damit du im Highscore verewigt wirst. Klicke anschließend auf das rote Feld");
        }

        // wenn erneut "rot" geklickt, wird die Namenseingabe beendet
        if(x > 110 && x < 210 && y > 10 && y < 110 && spielBeendet && !namenseingabeBeendet && !(name == ""))
        {
            namenseingabeBeendet = true;
            Datenbankanbindung dbAnbindung;
            dbAnbindung = new Datenbankanbindung();
            dbAnbindung.DatensatzEintragen(name, punktestand);
            dbAnbindung.ErgebnistabelleAusgeben();
            dbAnbindung.VerbindungSchließen();
        }
    }

    /**
     * Routine für Tastendruck
     * @param taste gedrückte Taste
     */
    @Override void TasteGedrückt(char taste)
    {
        if(spielBeendet && !namenseingabeBeendet)
        {
            name = name + taste;
            hinweis.TextSetzen("Dein Name: " + name + " Klicke zum Beenden der Namenseingabe auf das rote Feld");

        }
    }
}
