
/**
 * Das Spiel
 * 
 * @author Klaus Reinold
 * @version 1.0
 */
class Spiel extends Ereignisbehandlung
{
    /** Referenzattribut des Vogels */
    Vogel vogel;

    /** Referenzattribute der Insekten */
    Insekt insekt1, insekt2;

    /** Referenzattribute der Berge */    
    Berge berge1, berge2;

    /** Punktestand */
    int punkte;

    /** Textfeld */
    Text t; 

    /** Name des Spielers */
    String name;

    /** Namenseingabe beendet? */
    boolean namenseingabeBeendet;

    /**
     * Konstruktor des Spiels
     */
    Spiel()
    {
        super();
        new Himmel();
        new Wiese();
        insekt1 = new Insekt(0);
        insekt1.PositionSetzen(700, 100);
        insekt2 = new Insekt(1);
        insekt2.PositionSetzen(500, 200);
        insekt2.ZeichneFlügelUnten();
        vogel = new Vogel();

        berge1 = new Berge();
        berge2 = new Berge();
        berge1.PositionSetzen(320,320);
        berge2.PositionSetzen(600, 340);
        vogel.Gehen(-50);

        TaktdauerSetzen(300);

        punkte = 0;
        t = new Text();
        t.SichtbarkeitSetzen(false);
        namenseingabeBeendet = true;
        name = "";
    }

    /**
     * Taktsteuerung
     */
    @Override void TaktImpulsAusführen()
    {
        punkte = punkte + 1;
        berge1.Bewegen();
        berge2.Bewegen();
        insekt1.Bewegen();
        insekt2.Bewegen();

        if(vogel.Berührt(insekt1))
        {
            insekt1.PositionSetzen(800, insekt1.YPositionGeben());
            punkte = punkte + 99;
        }

        if(vogel.Berührt(insekt2))
        {
            insekt2.PositionSetzen(800, insekt2.YPositionGeben());
            punkte = punkte + 99;
        }

        if(vogel.Berührt(berge1)||vogel.Berührt(berge2))
        {
            t.SichtbarkeitSetzen(true);
            t.TextSetzen("Punkte: " + punkte + " Bitte Name eingeben");
            t.TextGrößeSetzen(30);
            t.FarbeSetzen("weiß");
            t.PositionSetzen(0, 200);
            Anhalten();
            namenseingabeBeendet = false;
        }
    }

    /**
     * Tastendruck-Routine
     * Einlesen des Namens am Ende des Spiels
     * @param taste gedrückte Taste
     */
    @Override void TasteGedrückt(char taste)
    {
        if(taste == '#')
        {
            namenseingabeBeendet = true;
            InHighscorelisteEintragen();
        }
        if(!namenseingabeBeendet)
        {
            name = name + taste;
            t.TextSetzen("Dein Name: " + name + " Klicke zum Beenden die #-Taste.");

        }
    }
    
    /**
     * Aufbau der Verbindung mit Datenbank, Eintragen des Datensatzes und
     * Ausgabe der Highscore-Liste
     */
    void InHighscorelisteEintragen()
    {
        //Hier ergänzen
    }
}
